#include "cursed_disc.h"
#include "fstream.h"

cursed_colony::cursed_colony( char *fname, int total_ants, real a, int x, int y) :
    discrete_colony(
	fname, 
	total_ants, 
	a, 
	x, y)
{
    w = initscr() ;
    if( !has_colors() )
      perror("Terminal has no colors!") ;
    else
      start_color() ;
}

cursed_colony::~cursed_colony()
{
    endwin() ;
}

void
cursed_colony::draw()
{
    int x, y ;
    int s[20] ;
    for( x=0; x<20; x++) s[x] = 0 ;

    for( x=1; x<n+1; x++) init_pair(x,x,0) ;

    for( y=0; y<size_y; y++)
      for( x=0; x<size_x; x++) {
	    switch ( num_ants(x,y) ) {
	    case 0:
		if( env(x,y) == 1 )
		    mvaddch( y+1, x+1 , ' ' ) ;
		else if( env(x,y) > 1 )
		    mvaddch( y+1, x+1 , env(x,y)+'A' ) ;
		else
		    mvaddch( y+1, x+1 , '#' ) ;
		break ;
	    case 1:
		mvaddch( y+1,x+1, ant_record[ant(x,y,0)].sta+'a' ) ;
		mvchgat( y+1,x+1,1, (COLOR_PAIR((ant_record[ant(x,y,0)].sta+1))),
			 ant_record[ant(x,y,0)].sta+1, NULL ) ;
		s[ant_record[ant(x,y,0)].sta]++ ;
		break ;
	    default:
		mvaddch( y+1, x+1 , '+' ) ;
		s[ant_record[ant(x,y,0)].sta]++ ;
		s[ant_record[ant(x,y,1)].sta]++ ;
		break ;
	    }
      }
    wmove(w,size_y+0+1,1) ;
    wprintw(w,"state #ants") ;
    for(x=0; x<20;x++) {
      if( s[x] > 0 ) {
	wmove(w,size_y+x+2,1) ;
	wprintw(w," %c     %d ",x+'a',s[x]) ;
	mvchgat( size_y+x+2,2,1, (COLOR_PAIR((x+1))),
		 x+1, NULL ) ;
      }
    }
    wrefresh( w ) ;
    //    getch() ;
}






