#include "cursed_disc.h"
#include "std.h"

extern "C" {
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
}
  
int colony::default_size = 6 ;

#ifdef RAND_GNU
ACG *generator;
#endif


int main(int argc, char *argv[])
{
  extern char *optarg;
  //    extern int optind;
  char c ;
  char col_name[255], pop_name[255] ;
  int n_runs = 10 ;
  int total_time = 100 ;
  pop_name[0] = 0 ;
  int size_x = 20 ;
  int size_y = 20 ;
  int n_ants = 10 ;
  real alpha = 1.0 ;
  long seed = 42 ;
  int show_colony = 0 ;
  colony *pants ;

  strcpy( col_name, "test.nant" ) ;
  while( (c=getopt(argc,argv,"c:p:hr:t:x:y:n:a:s:SC")) != -1)
    switch(c) {
    case 'h':
      printf("try run a continious colony model\n") ;
      printf("try_col -c <colony> [-p <population>] [-h] [-r <number of runs>] [-t <time per run>]\n") ;
      printf("-x <size x> -y <size y> -n <total number of ants> -a <alpha> -S \n") ;
      exit(0) ;
      break ;
    case 'c':
      strcpy(col_name,optarg) ;
      break ;
    case 'p':
      strcpy(pop_name,optarg) ;
      break ;
    case 'r':
      sscanf(optarg,"%d",&n_runs) ;
      break ;
    case 't':
      sscanf(optarg,"%d",&total_time) ;
      break ;
    case 'x':
      sscanf(optarg,"%d",&size_x) ;
      break ;
    case 'y':
      sscanf(optarg,"%d",&size_y) ;
      break ;
    case 'n':
      sscanf(optarg,"%d",&n_ants) ;
      break ;
    case 'a':
      sscanf(optarg,"%lf",&alpha) ;
      break ;
    case 's':
      sscanf(optarg,"%ld",&seed) ;
      break ;
    case 'S':
      show_colony = 2 ;
      break ;
    case 'C':
      show_colony = 1 ;
      break ;
    }
	    
#ifdef RAND_GNU
  generator = new ACG( seed ) ;
#endif
    




  if( show_colony == 2 )
    pants = new cursed_colony( col_name, n_ants, alpha, size_x, size_y ) ;
  else  if( show_colony == 1 )
    pants = new discrete_colony( col_name, n_ants, alpha, size_x, size_y ) ;
  else
    pants = new colony( col_name) ;

  if( pop_name[0] == 0 ) 
    pants->uniform_population() ;
  else
    pants->read_population( pop_name ) ;
  

  real *sp = new real[pants->n] ;
  
  {

    int i,s ;

    int j ;

    for( j=0; j<n_runs; j++) {

      
      int t, dt_m ;
      real dt ;

      dt = 0.01; dt_m = 1 ;

      for( t=0; t< total_time; t++) {
	pants->transform() ;
	if( show_colony != 2 ) {
	  pants->printf_population() ;
	  printf("\n") ;
	}
	if( show_colony == 2 ) {
	  ((cursed_colony *)pants)->draw() ;
	}
      }
    }
	
	//	if(show_colony==2)	
	// ((cursed_colony *)pants)->draw() ;
	//else 
	  //	  pants->printf_population() ;
	  //	printf(" :%g",pants->c_p(1)) ;
	  //	 printf("\n") ;
	//{
	    //	  	  if( show_colony ) 
	    //	    if( getch() == 'q' )
	    //	      exit(0);
	// }
    }

#ifdef RAND_GNU
  delete generator ;
#endif
  exit(0) ;
}







