#include "gled_disc.h"
#include "std.h"



extern "C" {
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>
#include <stdio.h>
/*#include "glaux.h"*/
#include <GL/glut.h>
}

FILE *_IO_stderr_ =stderr;
FILE *_IO_stdout_ =stdout ;

int colony::default_size = 6 ;

#ifdef RAND_GNU
ACG *generator;
#endif

gled_colony *pants ;


void display()
{
    GLuint i;

    glClear (GL_COLOR_BUFFER_BIT);
    pants->draw() ;
    glFlush ();
    glutSwapBuffers();  
}


int n_per_display =1;
int cur_disp_count = 0 ;
int paused=(1!=1) ;

void run()
{
  if( !paused ) pants->transform() ;
  if( !paused && (cur_disp_count++) % n_per_display ==0) display() ;
}

void pause()
{
  paused=(1==1) ;
}

void unpause()
{
  paused=(1==0) ;
}

void slow_down()
{
  n_per_display++ ;
}

void speed_up()
{
  n_per_display-- ;
  if( n_per_display < 1) n_per_display=1 ;
}

void myReshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    /*    if (w <= h) 
	gluOrtho2D (0.0, 20, -5 * (GLfloat) h/(GLfloat) w, 
	    15 * (GLfloat) h/(GLfloat) w);
    else 
	gluOrtho2D (0.0, 20 * (GLfloat) w/(GLfloat) h, -5, 15); 
	*/
    gluOrtho2D (-1,-1,pants->size_y*2+1,pants->size_x*2+1); 
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

void keyboard(unsigned char ch, int x, int y) 
{
  switch( ch ) {
  case 'p':
    paused = !paused ;
    break ;
  case '.':
  case '>':
    speed_up() ;
    break ;
  case ',':
  case '<':
    slow_down() ;
    break ;
  case 'q':
    exit(0) ;
    break ;
  case '1': case '2': case '3': case '4': case '5': case '6':
  case '7': case '8': case '9': 
    n_per_display = (ch - '1')*3 + 1 ;
    break ;

  }
}

/////////////////////////////////////////////////////////

GLuint listName = 1;

void myinit (void)
{
    glNewList (listName, GL_COMPILE);
	glBegin (GL_LINES);
	glVertex2f (0.0, 0.0);
	glVertex2f (0.8, 0.6);
        glEnd() ;
	glBegin (GL_LINES);
	glVertex2f (0.0, 0.0);
	glVertex2f (0.0, 0.85);
	glEnd ();
	glBegin (GL_LINES);
	glVertex2f (0.0, 0.0);
	glVertex2f (-0.8, 0.6);
	glEnd ();
	glBegin (GL_LINES);
	glVertex2f (0.0, 0.0);
	glVertex2f (0.8, -0.6);
        glEnd() ;
	glBegin (GL_LINES);
	glVertex2f (0.0, 0.0);
	glVertex2f (0.0, -0.85);
	glEnd ();
	glBegin (GL_LINES);
	glVertex2f (0.0, 0.0);
	glVertex2f (-0.8, -0.6);
	glEnd ();
	glBegin (GL_LINES);
	glVertex2f (0.8, 0.0);
	glVertex2f (1.0, 0.5);
	glEnd ();
	glBegin (GL_LINES);
	glVertex2f (0.8, 0.0);
	glVertex2f (1.0, -0.5);
	glEnd ();
        glBegin( GL_TRIANGLES) ;
        glVertex2f (0.5,0.0) ;
	glVertex2f (0.8, 0.3);
	glVertex2f (0.8, -0.3);
        glEnd() ;
        glBegin( GL_TRIANGLES) ;
        glVertex2f (0.5,0.0) ;
	glVertex2f (0.0, 0.2);
	glVertex2f (-0.4, 0.0);
        glEnd() ;
        glBegin( GL_TRIANGLES) ;
        glVertex2f (0.5,0.0) ;
	glVertex2f (0.0, -0.2);
	glVertex2f (-0.4, 0.0);
        glEnd() ;
        glBegin( GL_TRIANGLES) ;
        glVertex2f (-0.3,0.0) ;
	glVertex2f (-0.8, 0.3);
	glVertex2f (-1.1, 0.0);
        glEnd() ;
        glBegin( GL_TRIANGLES) ;
        glVertex2f (-0.3,0.0) ;
	glVertex2f (-0.8, -0.3);
	glVertex2f (-1.1, 0.0);
        glEnd() ;
     glEndList ();
    //    glShadeModel (GL_FLAT);
}

void drawLine (void)
{
    glBegin (GL_LINES);
    glVertex2f (0.0, 0.5);
    glVertex2f (15.0, 0.5);
    glEnd ();
}

void nput_ant( double x, double y, double angle, int color )
{
  glPushMatrix() ;
  color*=3 ;
  glColor3f (1.0,0.0,0.0);
  glRotatef( angle * 45, 0, 0, 1 ) ;
  glTranslatef (x, y, 0.0);
  glCallList( listName) ;
  glPopMatrix() ;
}


void ndisplay(void)
{
    GLuint i;

    glClear (GL_COLOR_BUFFER_BIT);
    glColor3f (0.0, 1.0, 0.0);
    glRasterPos2f( -15,-15 ) ;
    for (i = 0; i < 3; i++) {
      nput_ant( 5.0 * i, 5.0 * i, i,i ) ;
    }	
    drawLine ();
    glFlush ();
}

void nmyReshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    /*    if (w <= h) 
	gluOrtho2D (0.0, 20, -5 * (GLfloat) h/(GLfloat) w, 
	    15 * (GLfloat) h/(GLfloat) w);
    else 
	gluOrtho2D (0.0, 20 * (GLfloat) w/(GLfloat) h, -5, 15); 
	*/
    gluOrtho2D(0,2.4*pants->size_y,2*pants->size_x,0) ;
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}
////////////////////////////////////////////////////////
#define REAL_MAIN
#ifndef REAL_MAIN
int main(int argc, char** argv)
{
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB | GLUT_DEPTH);
//    InitDisplayMode (AUX_SINGLE | AUX_RGB);
    glutInitWindowSize(400,400);
    glutInit(&argc, argv);
//    auxInitPosition (0, 0, 400, 400);
//    if (!auxInitWindow (argv[0]))
 //       auxQuit();
   	glutCreateWindow("Ants!");
    myinit ();
//    auxReshapeFunc (nmyReshape);
    glutDisplayFunc(ndisplay) ;
    glutMainLoop();
    return 0;
}
#endif
#ifdef REAL_MAIN
int main(int argc, char *argv[])
{
  extern char *optarg;
  //    extern int optind;
  char c ;
  char col_name[255], pop_name[255] ;
  int n_runs = 1 ;
  int total_time = 100 ;
  pop_name[0] = 0 ;
  int size_x = 20 ;
  int size_y = 20 ;
  int n_ants = 10 ;
  real alpha = 1.0 ;
  long seed = 42 ;
  int show_colony = FALSE ;

  strcpy( col_name, "test.nant" ) ;
  while( (c=getopt(argc,argv,"c:p:hr:t:x:y:n:a:s:S")) != -1)
    switch(c) {
    case 'h':
      printf("try run a continious colony model\n") ;
      printf("try_col -c <colony> [-p <population>] [-h] [-r <number of runs>] [-t <time per run>]\n") ;
      printf("-x <size x> -y <size y> -n <total number of ants> -a <alpha> -S \n") ;
      exit(0) ;
      break ;
    case 'c':
      strcpy(col_name,optarg) ;
      break ;
    case 'p':
      strcpy(pop_name,optarg) ;
      break ;
    case 'r':
      sscanf(optarg,"%d",&n_runs) ;
      break ;
    case 't':
      sscanf(optarg,"%d",&total_time) ;
      break ;
    case 'x':
      sscanf(optarg,"%d",&size_x) ;
      break ;
    case 'y':
      sscanf(optarg,"%d",&size_y) ;
      break ;
    case 'n':
      sscanf(optarg,"%d",&n_ants) ;
      break ;
    case 'a':
      sscanf(optarg,"%lf",&alpha) ;
      break ;
    case 's':
      sscanf(optarg,"%ld",&seed) ;
      break ;
    case 'S':
      {
	show_colony = TRUE ;
	break ;
      }
    }
	    
#ifdef RAND_GNU
  generator = new ACG( seed ) ;
#endif
    


  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
//  auxInitDisplayMode (AUX_DOUBLE | AUX_RGB);
//  auxInitPosition (0, 0, 550, 470);
  //  auxInitPosition (0, 0, 680, 570);
    glutInitWindowSize(400,400);
    glutInit(&argc, argv);
//  if (!auxInitWindow (argv[0]))
//    auxQuit();
   	glutCreateWindow("Ants!");
  myinit() ;
  

  //  if( show_colony )
    pants = new gled_colony( col_name, n_ants, alpha, size_x, size_y ) ;
  glShadeModel (GL_FLAT);
  //  else
  //    pants = new discrete_colony( col_name, n_ants, alpha, size_x, size_y ) ;

  real *sp = new real[pants->n] ;
  
  {

    //    pants->c_b( 0, 1, 1 ) = tr ;
    // pants->setup_c_nB() ;

    int i,s ;
    for( i=0; i<pants->n; i++)
      sp[i] = 0 ;

    s = 0 ;

    //    if( pop_name[0] != 0 ) 
    //  pop_name[1]++ ;
      if( pop_name[0] == 0 ) 
	pants->uniform_population() ;
      else
	pants->read_population( pop_name ) ;

//    auxKeyFunc (AUX_LEFT, speed_up);
//    auxKeyFunc (AUX_RIGHT, slow_down);           
//    auxKeyFunc (AUX_UP, unpause);           
//    auxKeyFunc (AUX_DOWN, pause);           
//      auxReshapeFunc (nmyReshape);
      glutKeyboardFunc(keyboard);     
      glutIdleFunc(run) ;
      glutDisplayFunc(display) ;
      glutMainLoop();
#ifdef RAND_GNU
  delete generator ;
#endif
    return 0;


  }
  exit(0) ;
}



#endif
