#ifdef _MICROSOFT_
#include <iostream.h>
#else
#include <stream.h>
#endif

#include <stdio.h>
#include "weighted.h"


random_bitter nomial::rb ;

#ifdef NeXT
#include <g++/values.h>
#else
#include <limits.h>
#endif


nomial::~nomial()
{
}

#ifdef LOADABLE
void multi_nomial::save( ostream &o)
{
  start_save( o ) ;
  o << left << " " << n << "  " << lleft << " " << lright << endl ;

  pleft->save(o) ;
  pright->save(o) ;

  end_save(o) ;
}

bool multi_nomial::load( istream &i)
{
  if( !start_load(i) )
    return false ;

  return nameless_load( i ) ;

}

bool multi_nomial::nameless_load( istream &i)
{
  i >> left  ;
  i >> n ;
  i >> lleft ;
  i >> lright ;

  string s ;
  binomial t ;

  i >> s ;

  if( s == nomial::class_name() ) {
    pleft = new nomial ;
    if( !pleft->nameless_load(i) ) {
      delete pleft ;
      return false;
    }
  } else if( s== t.class_name() ) {
    pleft = new binomial() ;
    if( !pleft->nameless_load(i) ) {
      delete pleft ;
      return false ;
    }
  } else if( s== class_name() ) {
    pleft = new multi_nomial ;
    if( !pleft->nameless_load( i ) ) {
      delete pleft ;
      return false ;
    }
  } else
    return false ;

  i >> s ;

  if( s == nomial::class_name() ) {
    pright = new nomial ;
    if( !pright->nameless_load(i) ) {
      delete pleft ;
      delete pright ;
      return false;
    }
  } else if( s== t.class_name() ) {
    pright = new binomial() ;
    if( !pright->nameless_load(i) ) {
      delete pleft ;
      delete pright ;
      return false ;
    }
  } else if( s== class_name() ) {
    pright = new multi_nomial ;
    if( !pright->nameless_load( i ) ) {
      delete pleft ;
      delete pright ;
      return false ;
    }
  } else {
    delete pleft ;
    return false ;
  }
  
  return end_load( i ) ;

}
    
#endif

multi_nomial::multi_nomial()
{
    pleft = NULL ;
    pright = NULL ;
    tot = 0 ;
    n = 0 ;
}

multi_nomial::multi_nomial( real l, int il, real r, int ir )  
{
    tot = l + r ;
    pleft = new nomial( l, il ) ;
    pright = new nomial( r, ir ) ;
    n = 2 ;
    //    left = l / tot  ;
    //    lleft = long(left * TOT) ;
    //    lright = TOT - lleft ;
    left = (real) l / tot  ;
    if( left > 0.999 ) {
      lleft = 2 * (unsigned long)((real) left * HALF_TOT) ;
      if( lleft == 0) {
	lleft = TOT_MINUS_ONE ;
	lright = 0 ;
      } else
	lright = (TOT_MINUS_ONE - lleft) + 1 ;
    } else {
      lleft = 2 * (unsigned long)((real) left * HALF_TOT) ;
      lright = (TOT_MINUS_ONE - lleft) + 1 ;
    }
}

multi_nomial::multi_nomial( const real *r, const int *a )
{
  pleft =  NULL ;
  pright = NULL ;
  tot = 0 ;
  n = 0 ;
  int i;
  for( i=0; r[i] >=0 ; i++)
    add( r[i], a[i] ) ;
}
  

void
multi_nomial::update_l()
{
  if( pright != NULL ) {
    left = (real) pleft->tot / tot  ;
    if( left > 0.999 ) {
      lleft = 2 * (unsigned long)((real) left * HALF_TOT) ;
      if( lleft == 0) {
	lleft = TOT_MINUS_ONE ;
	lright = 0 ;
      } else
	lright = (TOT_MINUS_ONE - lleft) + 1 ;
    } else {
      lleft = 2 * (unsigned long)((real) left * HALF_TOT) ;
      lright = (TOT_MINUS_ONE - lleft) + 1 ;
    }
  } else {
    left = 1 ;
    lright = 0 ;
    lleft = TOT_MINUS_ONE ;
  }
}


multi_nomial::~multi_nomial()
{
    if( pleft != NULL )
	delete pleft ;

    if( pright != NULL )
	delete pright ;
}

void
multi_nomial::reset()
{
    if( pleft != NULL )
	delete pleft ;
    pleft = NULL ;

    if( pright != NULL )
	delete pright ;
    pright = NULL ;

    tot = 0 ;
    n = 0 ;
}

void 
multi_nomial::add( real c, int ind )
{
    nomial *t = new nomial( c, ind ) ;
    add( t ) ;
}

void 
multi_nomial::check_add( nomial *&pa , nomial *t)
{
    if( pa->n_nom() == 1 ) {
	multi_nomial *next = new multi_nomial ;
	next->add( pa ) ;
	next->add( t ) ;
	pa = next ;
    } else
	((multi_nomial *)pa)->add( t ) ;
}

	 

void 
multi_nomial::add( nomial *t )
{
    n++ ;
    tot += t->tot ;
    if( pleft == NULL ) {
	pleft = t ;
    } else if( pright == NULL ) 
	pright = t ;
    else if( t->tot > pleft->tot ) {
	check_add( pright, pleft ) ;
	pleft = t ;
    } else if( t->tot > pright->tot ) {
	check_add( pleft, pright ) ;
	pright = t ;
    } else if( pright->tot > pleft->tot ) {
	check_add( pleft, t ) ;
    } else {
	check_add( pright, t ) ;
    }
    update_l() ;
}

#if 0
int multi_nomial::choose()
{
  //  static 
  unsigned long x = lleft ;
  //  static 
  unsigned long y = lright ;
  
  while( rb.bit() ) {
    x <<= 1 ;
    y <<= 1 ;
    if( x == y )
      return ( rb.bit() ? pleft->choose() : pright->choose() ) ;
  }
  return ( x > y) ? pleft->choose() : pright->choose() ;
}	
#endif

#if 0
int 
multi_nomial::choose()
{
     long x = lleft ;
     long y = lright ;
     if( x == y ) 
	return ( rb.bit() ? pleft->choose() : pright->choose() ) ;
     while( rb.bit() ) {
	x = ( x > HALF_TOT ) ? (x-HALF_TOT) : x ;
	y = ( y > HALF_TOT ) ? (y-HALF_TOT) : y ;
	if( x == y )
	    return ( rb.bit() ? pleft->choose() : pright->choose() ) ;
	else {
	  x <<= 1 ;
	  y <<= 1 ;
	}
    }
    return ( x > y) ? pleft->choose() : pright->choose() ;
}
#endif

int multi_nomial::choose()
{
  
  if( lleft == lright ) 
    return ( rb.bit() ? pleft->choose() : pright->choose() ) ;
  else if( rb.bit() )
    return (lleft>lright)? pleft->choose() : pright->choose() ;
  else {
    unsigned long x = lleft ;
    unsigned long y = lright ;
    do { // NOTE: anything inside the loop is executed once on average!
      x <<= 1 ;
      y <<= 1 ;
      if( x == y ) 
	return ( rb.bit() ? pleft->choose() : pright->choose() ) ;
    }  while( rb.bit() ) ;
    return (x>=y) ? pleft->choose() : pright->choose() ;
  }
}


multi_nomial &multi_nomial::operator=(const multi_nomial &m) 
{
  cout << "hey! do not do this!\n" ;
  return *this ;
}

#ifdef LOADABLE
void binomial::save( ostream &o)
{
  start_save(o) ;

  o << left << "  " ;
  o << ileft << " " << iright << "  " ;
  
  end_save(o) ;
}

bool binomial::load( istream &i )
{
  if( !start_load(i) )
    return false ;

  return nameless_load(i) ;
}

bool binomial::nameless_load( istream &i )
{

  i >>  left ;
  i >> ileft ;
  i >> iright ;

  binomial temp(left, ileft, 1-left, iright) ;
  *this = temp ;

  return end_load(i) ;
}
#endif


binomial::binomial( real l, int il, real r, int ir ) 
  :ileft(il), iright(ir)
{
    tot = l + r ;
    left = (real)l / tot  ;
    lleft = 2 * (unsigned long)((real) left *HALF_TOT) ;
    lright = (TOT_MINUS_ONE - lleft) + 1 ;
    //    cout << lleft << " " << lright << endl;
}

int binomial::choose()
{
  
  if( lleft == lright ) 
    return ( rb.bit() ? ileft : iright ) ;
  else if( rb.bit() )
    return (lleft>lright)? ileft : iright ;
  else {
    static unsigned long x ; x  = lleft ;
    static unsigned long y ; y = lright ;
    do { // NOTE: anything inside the loop is executed once on average!
      x <<= 1 ;
      y <<= 1 ;
      if( x == y ) 
	return ( rb.bit() ? ileft : iright ) ;
    }  while( rb.bit() ) ;
    return (x>y) ? ileft : iright ;
  }
}


#ifdef NEED_MAIN

main()
{
    binomial m(0.05,1,0.95,0) ;

    int i,s ;
    

    s = 0 ;
    for( i=0; i< 10000000; i++) {
      if( m.choose()   ) 
	s++ ;
    }
    cout << s << "\n" ;
}
#endif
