#ifndef _WEIGHTED_H
#define _WEIGHTED_H

#include "std.h"
#ifdef LOADABLE
#inclde "loadable.h"
#endif

#ifdef NeXT
#include <g++/values.h>
#elif defined( _MICROSOFT_ )
#include <limits.h>
#define MAXLONG LONG_MAX
#else
#include <values.h>
#endif

#ifndef BITS
#define BITS(x) _TYPEBITS(x)
#endif

const unsigned long HALF_TOT = 1 << (BITS(unsigned long)-1) ;
const unsigned long TOT_MINUS_ONE = HALF_TOT*2-1 ;


class random_bitter {
    unsigned long rbits, nbits ;
#ifndef USE_INT_FOR_RANDOM
    void reset() { 
      rbits = random_long() ;
      nbits = 1 << (BITS(long)-1) ; // number of bit minus 1.
    } ;
#else
    void reset() { 
      rbits = random_int();/*random_int()*/ ;
      nbits = 1 << 15 ;
    } ;
#endif

public:
    random_bitter() {  reset() ; }
    inline int bit() {
      if( nbits==1)
	reset() ;
      else
	nbits >>= 1 ;
      return (rbits & nbits)==0 ; 
    }
} ;


class nomial
#ifdef LOADABLE
 :public listable<nomial>,public loadable 
#endif
{
public:
    static random_bitter rb ;
    real tot ;
    int iv ;
public:
    nomial() {} ;
    nomial( real t, int i ) : tot(t), iv(i) {} ;
    virtual ~nomial();
    virtual void reset() {};
    virtual int choose() {
	return iv ;
    } ;
    virtual int n_nom() { return 1 ; }
#ifdef LOADABLE
  /// class name is what is written to a file before the save, so the class can be identified.
  string class_name() { return string("Nomial") ; } ;
  //@}
#endif
} ;



class binomial: public nomial {
  real left ;
  int ileft, iright ;
  unsigned long lleft, lright ;
public:
  binomial( real l, int il, real r, int ir ) ;
  binomial( const binomial &b )
    :left( b.left), ileft( b.ileft) , iright(b.iright), lleft(b.lleft), lright(b.lright)
  {} ;
  binomial() {};
  int choose() ;
  real chance() { return left ; } ;
  int n_nom() { return 2 ; }
#ifdef LOADABLE
  void save( ostream &o) ;
  bool load( istream &i) ;
  bool nameless_load( istream &i) ;
  /// class name is what is written to a file before the save, so the class can be identified.
  string class_name() { return string("BiNomial") ; } ;
  //@}
#endif
};



class multi_nomial: public nomial {
  nomial *pleft, *pright ;
  real left ;
  int n ;
  unsigned long lleft, lright ;
public:
  multi_nomial()  ;
  multi_nomial( real l, int il, real r, int ir )  ;
  multi_nomial( const real *chance, const int *res ) ;
  virtual ~multi_nomial() ;
  void reset() ;
  int choose() ;
  void add( real c, int ind ) ;
  void add( nomial *t) ;
  void check_add( nomial *&pa , nomial *t) ;
  int n_nom() { return n ; }
 void update_l() ;
  multi_nomial &operator=(const multi_nomial &m) ;
#ifdef LOADABLE
  void save( ostream &o) ;
  bool nameless_load( istream &i) ;
  bool load( istream &i) ;
  /// class name is what is written to a file before the save, so the class can be identified.
  string class_name() { return string("MultiNomial") ; } ;
  //@}
#endif
};



#endif // _WEIGHTED_H
